收集 Proofpoint Secure Email Relay 日志
本文档介绍了如何使用 Google Cloud Storage V2 将 Proofpoint Secure Email Relay 日志注入到 Google Security Operations。
Proofpoint Secure Email Relay (SER) 是一项出站电子邮件安全服务,可为贵组织发送的邮件提供加密、数据泄露防护 (DLP) 和合规性强制执行功能。解析器从 SER 消息跟踪数据中提取字段,并将其映射到统一数据模型 (UDM),从而捕获电子邮件元数据、吞吐量指标、传送状态和用户活动。
准备工作
请确保满足以下前提条件:
- Google SecOps 实例
- 已启用 Cloud Storage API 的 GCP 项目
- 创建和管理 GCS 存储分区的权限
- 管理 GCS 存储分区的 IAM 政策的权限
- 创建 Cloud Run 服务、Pub/Sub 主题和 Cloud Scheduler 作业的权限
- 通过 API 密钥访问 Proofpoint Secure Email Relay 的特权
创建 Google Cloud Storage 存储桶
- 前往 Google Cloud 控制台。
- 选择您的项目或创建新项目。
- 在导航菜单中,依次前往 Cloud Storage > 存储分区。
- 点击创建存储分区。
提供以下配置详细信息:
设置 值 为存储桶命名 输入一个全局唯一的名称(例如 proofpoint-ser-logs)位置类型 根据您的需求进行选择(区域级、双区域、多区域) 位置 选择营业地点(例如 us-central1)存储类别 标准(建议用于经常访问的日志) 访问权限控制 均匀(推荐) 保护工具 可选:启用对象版本控制或保留政策 点击创建。
收集 Proofpoint SER API 凭据
获取 API 凭据
- 使用管理员凭据登录 Proofpoint Secure Email Relay 管理门户。
- 前往 Settings > API Keys。
- 点击生成或创建 API 密钥。
复制并妥善存储以下凭据:
- API 密钥:复制此值
- API 密钥:复制此值
验证权限
如需验证 API 凭据是否具有所需的权限,请执行以下操作:
- 登录 Proofpoint SER 管理员门户。
- 前往 Settings > API Keys。
- 确认 API 密钥已列出,且状态为有效。
- 验证密钥是否可以访问消息跟踪和报告端点。
测试 API 访问权限
在继续进行集成之前,请先测试您的凭据:
# Replace with your actual credentials API_KEY="<your-api-key>" API_SECRET="<your-api-secret>" # Test API access - retrieve recent messages curl -v -u "${API_KEY}:${API_SECRET}" \ "https://ser-api.proofpoint.com/v1/messages?startDate=$(date -u -v-1H +%Y-%m-%dT%H:%M:%SZ)&endDate=$(date -u +%Y-%m-%dT%H:%M:%SZ)"
为 Cloud Run 函数创建服务账号
Cloud Run 函数需要一个服务账号,该账号具有写入 GCS 存储桶的权限,并且可以由 Pub/Sub 调用。
创建服务账号
- 在 GCP 控制台中,依次前往 IAM 和管理 > 服务账号。
- 点击创建服务账号。
- 提供以下配置详细信息:
- 服务账号名称:输入
proofpoint-ser-collector-sa - 服务账号说明:输入
Service account for Cloud Run function to collect Proofpoint Secure Email Relay logs
- 服务账号名称:输入
- 点击创建并继续。
- 在向此服务账号授予对项目的访问权限部分中,添加以下角色:
- 点击选择角色。
- 搜索并选择 Storage Object Admin。
- 点击 + 添加其他角色。
- 搜索并选择 Cloud Run Invoker。
- 点击 + 添加其他角色。
- 搜索并选择 Cloud Functions Invoker。
- 点击继续。
- 点击完成。
必须拥有这些角色,才能:
- Storage Object Admin:将日志写入 GCS 存储桶并管理状态文件
- Cloud Run Invoker:允许 Pub/Sub 调用函数
- Cloud Functions Invoker:允许调用函数
授予对 GCS 存储桶的 IAM 权限
向服务账号授予对 GCS 存储桶的写入权限:
- 前往 Cloud Storage > 存储分区。
- 点击您的存储桶名称(例如
proofpoint-ser-logs)。 - 前往权限标签页。
- 点击授予访问权限。
- 提供以下配置详细信息:
- 添加主账号:输入服务账号电子邮件地址(例如
proofpoint-ser-collector-sa@PROJECT_ID.iam.gserviceaccount.com) - 分配角色:选择 Storage Object Admin
- 添加主账号:输入服务账号电子邮件地址(例如
- 点击保存。
创建 Pub/Sub 主题
创建一个 Pub/Sub 主题,Cloud Scheduler 将向该主题发布消息,而 Cloud Run 函数将订阅该主题。
- 在 GCP 控制台中,前往 Pub/Sub > 主题。
- 点击创建主题。
- 提供以下配置详细信息:
- 主题 ID:输入
proofpoint-ser-trigger - 将其他设置保留为默认值
- 主题 ID:输入
- 点击创建。
创建 Cloud Run 函数以收集日志
Cloud Run 函数将由来自 Cloud Scheduler 的 Pub/Sub 消息触发,以从 Proofpoint SER API 中提取消息日志并将其写入 GCS。
- 在 GCP 控制台中,前往 Cloud Run。
- 点击创建服务。
- 选择函数(使用内嵌编辑器创建函数)。
在配置部分中,提供以下配置详细信息:
设置 值 Service 名称 proofpoint-ser-collector区域 选择与您的 GCS 存储桶匹配的区域(例如 us-central1)运行时 选择 Python 3.12 或更高版本 在触发器(可选)部分中:
- 点击 + 添加触发器。
- 选择 Cloud Pub/Sub。
- 在选择 Cloud Pub/Sub 主题中,选择 Pub/Sub 主题 (
proofpoint-ser-trigger)。 - 点击保存。
在身份验证部分中:
- 选择需要进行身份验证。
- 检查 Identity and Access Management (IAM)。
向下滚动并展开容器、网络、安全性。
前往安全性标签页:
- 服务账号:选择服务账号 (
proofpoint-ser-collector-sa)
- 服务账号:选择服务账号 (
前往容器标签页:
- 点击变量和密钥。
- 为每个环境变量点击+ 添加变量:
变量名称 示例值 说明 GCS_BUCKETproofpoint-ser-logsGCS 存储桶名称 GCS_PREFIXser-logs日志文件的前缀 STATE_KEYser-logs/state.json状态文件路径 API_KEYyour-api-keyProofpoint SER API 密钥 API_SECRETyour-api-secretProofpoint SER API 密钥 MAX_RECORDS1000每次运行的记录数上限 PAGE_SIZE100每页记录数 LOOKBACK_HOURS1初始回溯期 在变量和 Secret 部分中,向下滚动到请求:
- 请求超时:输入
600秒(10 分钟)
- 请求超时:输入
前往设置标签页:
- 在资源部分中:
- 内存:选择 512 MiB 或更高值
- CPU:选择 1
- 在资源部分中:
在修订版本伸缩部分中:
- 实例数下限:输入
0 - 实例数上限:输入
100(或根据预期负载进行调整)
- 实例数下限:输入
点击创建。
等待服务创建完成(1-2 分钟)。
创建服务后,系统会自动打开内嵌代码编辑器。
添加函数代码
- 在入口点字段中输入 main。
在内嵌代码编辑器中,创建两个文件:
第一个文件 - main.py::
import functions_framework from google.cloud import storage import json import os import urllib3 from datetime import datetime, timezone, timedelta import time import base64 # Initialize HTTP client with timeouts http = urllib3.PoolManager( timeout=urllib3.Timeout(connect=5.0, read=30.0), retries=False, ) # Initialize Storage client storage_client = storage.Client() # Environment variables GCS_BUCKET = os.environ.get('GCS_BUCKET') GCS_PREFIX = os.environ.get('GCS_PREFIX', 'ser-logs') STATE_KEY = os.environ.get('STATE_KEY', 'ser-logs/state.json') API_KEY = os.environ.get('API_KEY') API_SECRET = os.environ.get('API_SECRET') MAX_RECORDS = int(os.environ.get('MAX_RECORDS', '1000')) PAGE_SIZE = int(os.environ.get('PAGE_SIZE', '100')) LOOKBACK_HOURS = int(os.environ.get('LOOKBACK_HOURS', '1')) API_BASE = "https://ser-api.proofpoint.com/v1" def parse_datetime(value: str) -> datetime: """Parse ISO datetime string to datetime object.""" if value.endswith("Z"): value = value[:-1] + "+00:00" return datetime.fromisoformat(value) @functions_framework.cloud_event def main(cloud_event): """ Cloud Run function triggered by Pub/Sub to fetch Proofpoint SER message logs and write to GCS. Args: cloud_event: CloudEvent object containing Pub/Sub message """ if not all([GCS_BUCKET, API_KEY, API_SECRET]): print('Error: Missing required environment variables') return try: # Get GCS bucket bucket = storage_client.bucket(GCS_BUCKET) # Load state state = load_state(bucket, STATE_KEY) # Determine time window now = datetime.now(timezone.utc) last_time = None if isinstance(state, dict) and state.get("last_event_time"): try: last_time = parse_datetime(state["last_event_time"]) last_time = last_time - timedelta(minutes=2) except Exception as e: print(f"Warning: Could not parse last_event_time: {e}") if last_time is None: last_time = now - timedelta(hours=LOOKBACK_HOURS) print(f"Fetching logs from {last_time.isoformat()} to {now.isoformat()}") # Build auth header (Basic auth with API key and secret) auth_string = f"{API_KEY}:{API_SECRET}" auth_bytes = auth_string.encode('utf-8') auth_b64 = base64.b64encode(auth_bytes).decode('utf-8') # Fetch messages records, newest_event_time = fetch_messages( auth_b64=auth_b64, start_time=last_time, end_time=now, page_size=PAGE_SIZE, max_records=MAX_RECORDS, ) if not records: print("No new log records found.") save_state(bucket, STATE_KEY, now.isoformat()) return # Write to GCS as NDJSON timestamp = now.strftime('%Y%m%d_%H%M%S') object_key = f"{GCS_PREFIX}/logs_{timestamp}.ndjson" blob = bucket.blob(object_key) ndjson = '\n'.join([json.dumps(record, ensure_ascii=False) for record in records]) + '\n' blob.upload_from_string(ndjson, content_type='application/x-ndjson') print(f"Wrote {len(records)} records to gs://{GCS_BUCKET}/{object_key}") # Update state with newest event time if newest_event_time: save_state(bucket, STATE_KEY, newest_event_time) else: save_state(bucket, STATE_KEY, now.isoformat()) print(f"Successfully processed {len(records)} records") except Exception as e: print(f'Error processing logs: {str(e)}') raise def load_state(bucket, key): """Load state from GCS.""" try: blob = bucket.blob(key) if blob.exists(): state_data = blob.download_as_text() return json.loads(state_data) except Exception as e: print(f"Warning: Could not load state: {e}") return {} def save_state(bucket, key, last_event_time_iso: str): """Save the last event timestamp to GCS state file.""" try: state = {'last_event_time': last_event_time_iso} blob = bucket.blob(key) blob.upload_from_string( json.dumps(state, indent=2), content_type='application/json' ) print(f"Saved state: last_event_time={last_event_time_iso}") except Exception as e: print(f"Warning: Could not save state: {e}") def fetch_messages(auth_b64: str, start_time: datetime, end_time: datetime, page_size: int, max_records: int): """ Fetch message logs from Proofpoint SER API with pagination. Args: auth_b64: Base64-encoded API key:secret for Basic auth start_time: Start time for log query end_time: End time for log query page_size: Number of records per page max_records: Maximum total records to fetch Returns: Tuple of (records list, newest_event_time ISO string) """ headers = { 'Authorization': f'Basic {auth_b64}', 'Accept': 'application/json', 'Content-Type': 'application/json', 'User-Agent': 'GoogleSecOps-ProofpointSERCollector/1.0', } records = [] newest_time = None page_num = 0 backoff = 1.0 offset = 0 start_date = start_time.strftime('%Y-%m-%dT%H:%M:%SZ') end_date = end_time.strftime('%Y-%m-%dT%H:%M:%SZ') while True: page_num += 1 if len(records) >= max_records: print(f"Reached max_records limit ({max_records})") break current_limit = min(page_size, max_records - len(records)) url = f"{API_BASE}/messages?startDate={start_date}&endDate={end_date}&offset={offset}&limit={current_limit}" try: response = http.request('GET', url, headers=headers) # Handle rate limiting with exponential backoff if response.status == 429: retry_after = int(response.headers.get('Retry-After', str(int(backoff)))) print(f"Rate limited (429). Retrying after {retry_after}s...") time.sleep(retry_after) backoff = min(backoff * 2, 30.0) continue backoff = 1.0 if response.status != 200: print(f"HTTP Error: {response.status}") response_text = response.data.decode('utf-8') print(f"Response body: {response_text}") return [], None data = json.loads(response.data.decode('utf-8')) if isinstance(data, list): page_results = data else: page_results = data.get('messages', data.get('results', data.get('data', []))) if not page_results: print(f"No more results (empty page)") break print(f"Page {page_num}: Retrieved {len(page_results)} messages") records.extend(page_results) # Track newest event time for event in page_results: try: event_time = event.get('date') or event.get('timestamp') or event.get('sentDate') if event_time: if newest_time is None or parse_datetime(event_time) > parse_datetime(newest_time): newest_time = event_time except Exception as e: print(f"Warning: Could not parse event time: {e}") # Check for more results if len(page_results) < current_limit: print(f"Reached last page (size={len(page_results)} < limit={current_limit})") break offset += len(page_results) except Exception as e: print(f"Error fetching messages: {e}") return [], None print(f"Retrieved {len(records)} total messages from {page_num} pages") return records, newest_time第二个文件 - requirements.txt::
functions-framework==3.* google-cloud-storage==2.* urllib3>=2.0.0
点击部署以保存并部署该函数。
等待部署完成(2-3 分钟)。
创建 Cloud Scheduler 作业
Cloud Scheduler 会定期向 Pub/Sub 主题发布消息,从而触发 Cloud Run 函数。
- 在 GCP Console 中,前往 Cloud Scheduler。
- 点击创建作业。
提供以下配置详细信息:
设置 值 名称 proofpoint-ser-collector-hourly区域 选择与 Cloud Run 函数相同的区域 频率 0 * * * *(每小时一次,整点时)时区 选择时区(建议选择世界协调时间 [UTC]) 目标类型 Pub/Sub 主题 选择 Pub/Sub 主题 ( proofpoint-ser-trigger)消息正文 {}(空 JSON 对象)点击创建。
时间表频率选项
根据日志量和延迟时间要求选择频次:
| 频率 | Cron 表达式 | 使用场景 |
|---|---|---|
| 每隔 5 分钟 | */5 * * * * |
大批量、低延迟 |
| 每隔 15 分钟 | */15 * * * * |
搜索量中等 |
| 每小时 | 0 * * * * |
标准(推荐) |
| 每 6 小时 | 0 */6 * * * |
低成交量、批处理 |
| 每天 | 0 0 * * * |
历史数据收集 |
测试集成
- 在 Cloud Scheduler 控制台中,找到您的作业。
- 点击强制运行以手动触发作业。
- 等待几秒钟。
- 前往 Cloud Run > 服务。
- 点击函数名称 (
proofpoint-ser-collector)。 - 点击日志标签页。
验证函数是否已成功执行。查找:
Fetching logs from YYYY-MM-DDTHH:MM:SS+00:00 to YYYY-MM-DDTHH:MM:SS+00:00 Page 1: Retrieved X messages Wrote X records to gs://proofpoint-ser-logs/ser-logs/logs_YYYYMMDD_HHMMSS.ndjson Successfully processed X records前往 Cloud Storage > 存储分区。
点击您的存储桶名称 (
proofpoint-ser-logs)。前往前缀文件夹 (
ser-logs/)。验证是否已创建具有当前时间戳的新
.ndjson文件。
如果您在日志中看到错误,请执行以下操作:
- HTTP 401:检查环境变量中的 API 密钥和 API Secret
- HTTP 403:验证 API 密钥是否具有对消息跟踪端点的访问权限
- HTTP 429:速率限制 - 函数将自动重试并进行退避
- 缺少环境变量:检查是否已设置所有必需的变量
检索 Google SecOps 服务账号
Google SecOps 使用唯一的服务账号从您的 GCS 存储桶中读取数据。您必须授予此服务账号对您的存储桶的访问权限。
获取服务账号电子邮件地址
- 依次前往 SIEM 设置 > Feed。
- 点击添加新 Feed。
- 点击配置单个 Feed。
- 在 Feed 名称字段中,输入 Feed 的名称(例如
Proofpoint SER Logs)。 - 选择 Google Cloud Storage V2 作为来源类型。
- 选择 ProofPoint Secure Email Relay 作为日志类型。
- 点击获取服务账号。
系统会显示一个唯一的服务账号电子邮件地址,例如:
chronicle-12345678@chronicle-gcp-prod.iam.gserviceaccount.com复制此电子邮件地址,以便在下一步中使用。
点击下一步。
为以下输入参数指定值:
存储桶网址:输入带有前缀路径的 GCS 存储桶 URI:
gs://proofpoint-ser-logs/ser-logs/- 替换:
proofpoint-ser-logs:您的 GCS 存储桶名称。ser-logs:存储日志的可选前缀/文件夹路径(留空表示根目录)。
- 替换:
来源删除选项:根据您的偏好选择删除选项:
- 永不:转移后永不删除任何文件(建议用于测试)。
- 删除已转移的文件:在成功转移后删除文件。
删除已转移的文件和空目录:成功转移后删除文件和空目录。
文件存在时间上限:包含在过去指定天数内修改的文件(默认值为 180 天)
资产命名空间:资产命名空间
注入标签:要应用于此 Feed 中事件的标签
点击下一步。
在最终确定界面中查看新的 Feed 配置,然后点击提交。
向 Google SecOps 服务账号授予 IAM 权限
3Google SecOps 服务账号需要具有 GCS 存储桶的 Storage Object Viewer 角色。
- 前往 Cloud Storage > 存储分区。
- 点击您的存储桶名称(例如
proofpoint-ser-logs)。 - 前往权限标签页。
- 点击授予访问权限。
- 提供以下配置详细信息:
- 添加主账号:粘贴 Google SecOps 服务账号电子邮件地址
- 分配角色:选择 Storage Object Viewer
点击保存。
UDM 映射表
| 日志字段 | UDM 映射 | 逻辑 |
|---|---|---|
| 状态、详细信息、data.throughputLimit、data.throughput、data.totalThroughput、log_metadata.totalThroughput、data.averageDailyThroughput、data.throughputForecast、data.remainingThroughput、data.acceptedThroughput、data.licenseStartDate、data.licenseEndDate、data.average7DayThroughput、data.average30DayThroughput、data.requestedMessages、data.acceptedMessages、data.sentMessages、data.deliveredMessages、data.avgAcceptedMessageSize、data.blockedMessages、data.quarantinedMessages、data.rejectedMessages、data.requestedThroughput、data.totalMessages、data.undeliveredMessages | additional.fields | 来自状态映射的合并标签(以字符串值表示)、详细信息嵌套映射(以扁平化键和字符串值表示)以及各种数据字段(以字符串值或数值表示) |
| desc, data.name | metadata.description | 如果 desc 不为空,则返回 desc 中的值;否则,返回 data.name |
| event_type | metadata.event_type | 如果 user_present 为 true,则设置为 EMAIL_TRANSACTION;否则,设置为 GENERIC_EVENT |
| metadata.product_name | 设置为“PROOFPOINT SER” | |
| metadata.vendor_name | 设置为“PROOFPOINT” | |
| fromEnvelope | network.email.bounce_address | 如果与电子邮件地址模式匹配,则来自 fromEnvelope 的值 |
| fromHeader | network.email.from | 如果与电子邮件模式匹配,则来自 fromHeader 的值 |
| applicationName | principal.administrative_domain | 直接复制值 |
| principal_host | principal.asset.hostname | 直接复制值 |
| principal_host | principal.hostname | 直接复制值 |
| principal_port | principal.port | 从 principal_port 转换的值(转换为整数) |
| userId、data.relayUserId | principal.user.product_object_id | 如果 userId 不为空,则返回 userId 中的值;否则,返回 data.relayUserId |
| applicationUserName | principal.user.user_display_name | 直接复制值 |
| senderName | target.administrative_domain | 直接复制值 |
| senderId | target.user.product_object_id | 直接复制值 |
data.throughput" and "data.totalThroughput |
additional.fields |
从变更日志映射 |
data.throughputLimit", "data.averageDailyThroughput", "data.throughputForecast", "data.remainingThroughput", "data.acceptedThroughput", "data.licenseStartDate", "data.licenseEndDate", "data.average7DayThroughput", "data.average30DayThroughput", "data.requestedMessages", "data.acceptedMessages", "data.sentMessages", "data.deliveredMessages", "data.avgAcceptedMessageSize", "data.blockedMessages", "data.quarantinedMessages", "data.rejectedMessages", "data.requestedThroughput", "data.totalMessages", and "data.undeliveredMessages |
additional.fields |
从变更日志映射 |